var manageFormMappingApp = angular.module('manageFormMappingApp', ['ngRoute', 'manageFormMapping', 'wemServices', 'wemDirectives']);

manageFormMappingApp.config(function($routeProvider) {
    $routeProvider
        .when('/list', {
            templateUrl: ManagersContext.localTemplatesPath + '/form-mapping/list.html',
            controller: 'ListFormMappingController'
        })
        .when('/add', {
            templateUrl: ManagersContext.localTemplatesPath + '/form-mapping/form.html',
            controller: 'EditFormMappingController',
            resolve: {
                formMapping: function() {
                    return {
                        id: 'form-mapping_' + ManagersUtils.generateId(),
                        scope: ManagersContext.dmfScope,
                        additionalPaths:[]
                    };
                },
                isNew: function() {
                    return true;
                }
            }
        })
        .when('/edit/:formMappingId', {
            templateUrl: ManagersContext.localTemplatesPath + '/form-mapping/form.html',
            controller: 'EditFormMappingController',
            resolve: {
                formMapping: function( $q, $route, formMappingService) {
                    var formMapping = $q.defer();
                    formMappingService.get($route.current.params.formMappingId).success(
                        function (data) {
                            formMapping.resolve(formMappingService.serverToLocalFormMapping(data));
                        }
                    );
                    return formMapping.promise;
                },
                isNew: function() {
                    return false;
                }
            }
        })
        .otherwise( {
            redirectTo: '/list'
        });
});