angular.module('manageGoalsApp', [
    'ngRoute',
    'manageGoals',
    'wemServices',
    'wemDirectives'
])
    .config(['$routeProvider',
        function($routeProvider) {
            $routeProvider.
                when('/goals', {
                    templateUrl: ManagersContext.localTemplatesPath + '/goals/goal-list.html',
                    controller: 'ManageGoalsListCtrl',
                    reloadOnSearch: false,
                    resolve: {
                        // resolve rule here to avoid async issue using deferred API
                        "currentCampaign": function () {
                            return undefined
                        }
                    }
                }).
                when('/newGoal', {
                    templateUrl: ManagersContext.localTemplatesPath + '/goals/goal-create.html',
                    controller: 'CreateGoalCtrl'
                }).
                when('/goal/:goalId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/goals/goal-edit.html',
                    controller: 'ManageGoalCtrl',
                    resolve: {
                        // resolve goal here to avoid async issue using deferred API
                        "goal": function( $q, $route, goalService) {
                            var goal = $q.defer();
                            goalService.getGoal($route.current.params.goalId).success(function(goalData){
                                goal.resolve(goalData);
                            });
                            return goal.promise;
                        }
                    }
                }).
                when('/goal-report/:goalId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/goals/goal-report.html',
                    controller: 'ManageGoalReportCtrl',
                    resolve: {
                        // resolve goal here to avoid async issue using deferred API
                        "goal": function ($q, $route, goalService) {
                            var goal = $q.defer();
                            goalService.getGoal($route.current.params.goalId).success(function (goalData) {
                                goal.resolve(goalData);
                            });
                            return goal.promise;
                        }
                    }
                }). // ABO a voir si le garde  ????
                when('/profiles', {
                    templateUrl: ManagersContext.localTemplatesPath + '/campaigns/profiles-list.html'
                }).
                otherwise({
                    redirectTo: '/goals'
                });
        }])
;
