angular.module('mostVisitedPagesApp', [
    'ngRoute',
    'manageMostVisited',
    'wemServices',
    'wemDirectives',
    'manageProfiles'
])
    .config(['$routeProvider',
        function ($routeProvider) {
            $routeProvider.
                when('/mostvisited', {
                    templateUrl: ManagersContext.localTemplatesPath + '/mostvisited-pages/mostvisited-list.html',
                    controller: 'ManageMostVisitedListCtrl'

                }).
                when('/mostvisited/selected', {
                    templateUrl: ManagersContext.localTemplatesPath + '/mostvisited-pages/profile-details.html',
                    controller: 'MostVisitedCtrl'
                }).
                when('/mostvisited/selected/profile/:profileId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-view.html',
                    controller: 'ManageProfileCtrl',
                    resolve: {
                        // resolve profile here to avoid async issue using deferred API
                        "profile": function ($q, $route, profileService) {
                            var profile = $q.defer();
                            profileService.getProfile($route.current.params.profileId).success(function (profileData) {
                                if(profileData) {
                                    profile.resolve(profileData);
                                } else {
                                    profile.reject("profile_not_found")
                                }

                            });
                            return profile.promise;
                        }
                    }
                }).

                otherwise({
                    redirectTo: '/mostvisited'
                });
        }])
;


