<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt_rt" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<c:choose>
    <c:when test="${currentNode.properties['wem:anonymizeProfile'].boolean or currentNode.properties['wem:activatePrivateBrowsing'].boolean}">
        <template:addResources type="css" resources="bootstrap.min.css"/>
        <template:addResources type="javascript" resources="jquery.min.js,bootstrap-transition.js,bootstrap-modal.js"/>

        <fmt:message key="wemnt_privacySettingsModal.wem_activatePrivateBrowsing.button.start" var="startPrivateBrowsingButton"/>
        <fmt:message key="wemnt_privacySettingsModal.wem_activatePrivateBrowsing.button.stop" var="stopPrivateBrowsingButton"/>
        <template:addResources>
            <script>
                var manageWemPrivacy = {
                    init: function() {
                        $('body').append($('#privacyModal_${currentNode.identifier}'));
                    },
                    initPrivacyButton: function () {
                        <c:if test="${currentNode.properties['wem:activatePrivateBrowsing'].boolean and not renderContext.editMode}">
                        $('#privateBrowsingError_${currentNode.identifier}').hide();
                        if (cxs.anonymousBrowsing) {
                            $('#privateBrowsing_${currentNode.identifier}').addClass('btn-success');
                            $('#privateBrowsing_${currentNode.identifier}').html('${functions:escapeJavaScript(stopPrivateBrowsingButton)}');
                        } else {
                            $('#privateBrowsing_${currentNode.identifier}').addClass('btn-danger');
                            $('#privateBrowsing_${currentNode.identifier}').html('${functions:escapeJavaScript(startPrivateBrowsingButton)}');
                        }
                        </c:if>
                        <c:if test="${currentNode.properties['wem:anonymizeProfile'].boolean}">
                        $('#anonymizeError_${currentNode.identifier}').hide();
                        </c:if>
                    }
                };

                $(document).ready(function () {
                    manageWemPrivacy.init();
                });
            </script>
        </template:addResources>

        <c:choose>
            <c:when test="${currentNode.properties['wem:buttonType'].string eq 'tagButton'}">
                <button type="button" class="btn btn-primary"
                        data-toggle="modal" data-target="#privacyModal_${currentNode.identifier}"
                        onclick="manageWemPrivacy.initPrivacyButton()">
                    <fmt:message key="wemnt_privacySettingsModal.button.privacy"/>
                </button>
            </c:when>
            <c:otherwise>
                <a href="#privacyModal_${currentNode.identifier}"
                   data-toggle="modal" role="button"
                   onclick="manageWemPrivacy.initPrivacyButton()">
                    <fmt:message key="wemnt_privacySettingsModal.button.privacy"/>
                </a>
            </c:otherwise>
        </c:choose>


        <div id="privacyModal_${currentNode.identifier}" class="modal hide fade">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h3><fmt:message key="wemnt_privacySettingsModal.title.privacy"/></h3>
            </div>

            <div class="modal-body">
                <c:if test="${renderContext.editMode}">
                    <div class="alert alert-info">
                        <fmt:message key="wemnt_privacySettingsModal.info.buttonDisabled"/>
                    </div>
                </c:if>

                <p>
                    <fmt:message key="wemnt_privacySettingsModal.info"/>
                </p>

                <c:if test="${currentNode.properties['wem:anonymizeProfile'].boolean}">
                    <button type="button" class="btn"
                            onclick="wem.anonymizeProfile('#anonymizeError_${currentNode.identifier}')"
                            <c:if test="${renderContext.editMode}">disabled</c:if>>
                        <fmt:message key="wemnt_privacySettingsModal.wem_anonymizeProfile.button"/>
                    </button>
                    <div id="anonymizeError_${currentNode.identifier}" class="alert alert-error">
                        <fmt:message key="wemnt_privacySettingsModal.wem_anonymizeProfile.error"/>
                    </div>
                </c:if>

                <c:if test="${currentNode.properties['wem:activatePrivateBrowsing'].boolean}">
                    <button id="privateBrowsing_${currentNode.identifier}"
                            type="button" class="btn"
                            onclick="wem.togglePrivateBrowsing('#privateBrowsingError_${currentNode.identifier}')"
                            <c:if test="${renderContext.editMode}">disabled</c:if>>
                        <c:if test="${renderContext.editMode}">
                            ${startPrivateBrowsingButton}
                        </c:if>
                    </button>
                    <div id="privateBrowsingError_${currentNode.identifier}" class="alert alert-error">
                        <fmt:message key="wemnt_privacySettingsModal.wem_activatePrivateBrowsing.error"/>
                    </div>
                </c:if>
            </div>

            <div class="modal-footer">
                <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
                    <fmt:message key="label.close"/>
                </button>
            </div>
        </div>
    </c:when>
    <c:otherwise>
        <c:if test="${renderContext.editMode}">
            <div class="alert alert-error">
                <fmt:message key="wemnt_privacySettingsModal.error.noButtonToDisplay"/>
            </div>
        </c:if>
    </c:otherwise>
</c:choose>
