<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<jsp:include page="../../commons/adminBaseImports.jsp"/>

<template:addResources type="css"
                       resources="angular-ui-notification.min.css"/>
<template:addResources type="javascript" resources="manage-settings.js"/>

<header class="pageHead dark-grey-bg">
    <h1><fmt:message key="serverSettings.manageWem.title"/></h1>
</header>

<div class="box-2 baseSetCard" ng-app="manageSettings">
    <div ng-controller="manageSettingsController">
        <form name="settingsForm" novalidate>

            <fieldset>

                <div class="titleContBaseSet">
                    <legend><fmt:message key='serverSettings.manageWem.configuration'/></legend>
                    <div ng-if="!hasSettings" class="titleDescBaseSet"><fmt:message key='serverSettings.manageWem.configuration.description'/></div>
                </div>

                <div class="row">
                    <div class="col-md-6" ng-if="!hasSettings">
                        <foldable-input model="settings.baseContextServerUrl" label-key="serverSettings.manageWem.contextServerPublicUrl" type="text"
                                        required="true" name="serverUrl"></foldable-input>
                    </div>
                    <div class="col-md-6">
                        <foldable-input model="settings.contextServerScope" label-key="serverSettings.manageWem.contextServerScope" type="text" required="true" name="scope"></foldable-input>
                    </div>

                </div>

                <div class="row hasSetSep fixtablewidth" ng-if="hasSettings">
                    <table class="table table-bordered table-hover table-bordered-mf" id="${moduleTableId}">
                        <thead>
                        <tr>
                            <th><fmt:message key="serverSettings.manageSettings.publicUrls"/></th>
                            <th><fmt:message key="serverSettings.manageSettings.securesUrls"/></th>
                            <th><fmt:message key="serverSettings.manageSettings.hostName"/></th>
                            <th><fmt:message key="serverSettings.manageSettings.master"/></th>
                            <th><fmt:message key="serverSettings.manageSettings.cpuLoad"/></th>
                            <th><fmt:message key="serverSettings.manageSettings.loadAverage"/></th>
                            <th><fmt:message key="serverSettings.manageSettings.uptime"/></th>
                        </tr>
                        </thead>
                        <tbody>
                            <tr ng-repeat="publicUrl in settings.publicUrls">
                                <td>{{publicUrl}}</td>
                                <td>{{settings.secureUrls[$index]}}</td>
                                <td>{{settings.clusterNodeInfo[publicUrl].hostName}}</td>
                                <td><i ng-show="settings.clusterNodeInfo[publicUrl].master" class="fa fa-check"></i></td>
                                <td>{{settings.clusterNodeInfo[publicUrl].cpuLoad}}</td>
                                <td>
                                    <ul ng-repeat="load in settings.clusterNodeInfo[publicUrl].loadAverage track by $index">
                                        <li>{{load}}</li>
                                    </ul>
                                </td>
                                <td>{{settings.clusterNodeInfo[publicUrl].uptime}}</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="row" ng-if="!hasSettings">
                    <div class="col-md-12">

                        <div class="checkBaseSet">
                            <label class="label--checkbox" for="contextServerTrustAllCertificates">
                                <input type="checkbox" class="checkbox" id="contextServerTrustAllCertificates" ng-model="settings.contextServerTrustAllCertificates"/>
                                <fmt:message key='serverSettings.manageWem.contextServerTrustAllCertificates'/>
                            </label>
                        </div>

                    </div>
                </div>
                <div class="row" ng-if="!hasSettings">
                    <div class="col-md-6">
                        <foldable-input model="settings.contextServerUsername" label-key="serverSettings.manageWem.contextServerUsername" type="text"></foldable-input>
                    </div>
                    <div class="col-md-6">
                        <foldable-input model="settings.contextServerPassword" label-key="serverSettings.manageWem.contextServerPassword" type="password"></foldable-input>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6">
                        <foldable-input model="settings.unomiKey" label-key="serverSettings.manageWem.unomiKey" type="text"></foldable-input>
                    </div>
                    <div class="col-md-6">
                        <foldable-input model="settings.googleAPIKey" label-key="serverSettings.manageWem.googleAPIKey" type="text"></foldable-input>
                    </div>
                </div>
                <div class="row">
                    <div class="baseSetButs">
                        <button class="btn btn-primary blue-color" ng-click="save()">
                            <fmt:message key='label.save'/>
                        </button>
                        <button class="btn btn-danger pink-color" ng-if="hasSettings" ng-click="delete()">
                            <fmt:message key='label.delete'/>
                        </button>
                        <button class="btn btn-danger dark-yellow-color" ng-if="hasSettings" ng-click="tryPurgeScope()">
                            <fmt:message key='label.purge.scope'/>
                        </button>
                    </div>
                </div>
            </fieldset>

        </form>

<%--        <form class="form-inline">

            <fieldset>
                <legend><fmt:message key='serverSettings.manageWem.purge'/></legend>
                <div class="form-group">
                    <label for="days"><fmt:message key='serverSettings.manageWem.purgeNumberOfDays'/></label>
                    <input class="form-control" id="days" name="days" value="60"/>

                    <button class="btn btn-danger" id="submitPurge" type="submit" name="_eventId_purge"><i
                            class="fa fa-times"></i>&nbsp;<fmt:message key='serverSettings.manageWem.purge'/>
                    </button>
                </div>
            </fieldset>

        </form>--%>
    </div>
</div>
